=== modified file 'configure.ac'
--- configure.ac	2008-09-16 07:29:45 +0000
+++ configure.ac	2008-09-25 08:57:27 +0000
@@ -291,7 +291,7 @@
 then
   # Disable exceptions as they seams to create problems with gcc and threads.
   # drizzled doesn't use run-time-type-checking, so we disable it.
-  AM_CXXFLAGS="${AM_CXXFLAGS} -fno-exceptions -fno-rtti"
+  AM_CXXFLAGS="${AM_CXXFLAGS} -fno-exceptions"
 fi
 
 DRIZZLE_PROG_AR

=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2008-09-15 21:41:39 +0000
+++ drizzled/Makefile.am	2008-09-25 08:57:27 +0000
@@ -72,6 +72,8 @@
 		 $(CXXLDFLAGS) \
 		 $(LIBDL_LIBS) $(LIBEVENT_LIBS)
 
+drizzled_LDFLAGS = -Wl,--export-dynamic
+
 noinst_HEADERS = item.h \
 		 authentication.h \
 		 item_func.h \

=== modified file 'drizzled/common_includes.h'
--- drizzled/common_includes.h	2008-09-16 04:26:53 +0000
+++ drizzled/common_includes.h	2008-09-25 08:57:27 +0000
@@ -288,7 +288,6 @@
 /* Drizzle server data type class definitions */
 #include <drizzled/field.h>
 #include "protocol.h"
-#include "sql_udf.h"
 #include "item.h"
 
 extern my_decimal decimal_zero;

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2008-09-16 00:00:48 +0000
+++ drizzled/handler.h	2008-09-26 23:31:37 +0000
@@ -367,7 +367,6 @@
 #define HA_CREATE_USED_COMMENT          (1L << 16)
 #define HA_CREATE_USED_CONNECTION       (1L << 18)
 #define HA_CREATE_USED_KEY_BLOCK_SIZE   (1L << 19)
-#define HA_CREATE_USED_TRANSACTIONAL    (1L << 20)
 #define HA_CREATE_USED_PAGE_CHECKSUM    (1L << 21)
 #define HA_CREATE_USED_BLOCK_SIZE       (1L << 22)
 
@@ -770,15 +769,11 @@
   uint32_t used_fields;
   uint32_t key_block_size;
   uint32_t block_size;
-  SQL_LIST merge_list;
   handlerton *db_type;
   enum row_type row_type;
   uint null_bits;                       /* NULL bits at start of record */
   uint options;				/* OR of HA_CREATE_ options */
-  uint merge_insert_method;
   uint extra_size;                      /* length of extra data segment */
-  /* 0 not used, 1 if not transactional, 2 if transactional */
-  enum ha_choice transactional;
   bool table_existed;			/* 1 in create if table existed */
   bool frm_only;                        /* 1 if no ha_create_table() */
   bool varchar;                         /* 1 if table has a VARCHAR */

=== modified file 'drizzled/item_create.cc'
--- drizzled/item_create.cc	2008-09-08 05:34:16 +0000
+++ drizzled/item_create.cc	2008-09-25 08:57:27 +0000
@@ -1461,7 +1461,7 @@
 Item*
 Create_udf_func::create(THD *thd, udf_func *udf, List<Item> *item_list)
 {
-  Item *func= NULL;
+  Item_func *func= NULL;
   int arg_count= 0;
 
   if (item_list != NULL)
@@ -1469,87 +1469,10 @@
 
   thd->lex->set_stmt_unsafe();
 
-  assert(   (udf->type == UDFTYPE_FUNCTION)
-              || (udf->type == UDFTYPE_AGGREGATE));
-
-  switch(udf->returns) {
-  case STRING_RESULT:
-  {
-    if (udf->type == UDFTYPE_FUNCTION)
-    {
-      if (arg_count)
-        func= new (thd->mem_root) Item_func_udf_str(udf, *item_list);
-      else
-        func= new (thd->mem_root) Item_func_udf_str(udf);
-    }
-    else
-    {
-      if (arg_count)
-        func= new (thd->mem_root) Item_sum_udf_str(udf, *item_list);
-      else
-        func= new (thd->mem_root) Item_sum_udf_str(udf);
-    }
-    break;
-  }
-  case REAL_RESULT:
-  {
-    if (udf->type == UDFTYPE_FUNCTION)
-    {
-      if (arg_count)
-        func= new (thd->mem_root) Item_func_udf_float(udf, *item_list);
-      else
-        func= new (thd->mem_root) Item_func_udf_float(udf);
-    }
-    else
-    {
-      if (arg_count)
-        func= new (thd->mem_root) Item_sum_udf_float(udf, *item_list);
-      else
-        func= new (thd->mem_root) Item_sum_udf_float(udf);
-    }
-    break;
-  }
-  case INT_RESULT:
-  {
-    if (udf->type == UDFTYPE_FUNCTION)
-    {
-      if (arg_count)
-        func= new (thd->mem_root) Item_func_udf_int(udf, *item_list);
-      else
-        func= new (thd->mem_root) Item_func_udf_int(udf);
-    }
-    else
-    {
-      if (arg_count)
-        func= new (thd->mem_root) Item_sum_udf_int(udf, *item_list);
-      else
-        func= new (thd->mem_root) Item_sum_udf_int(udf);
-    }
-    break;
-  }
-  case DECIMAL_RESULT:
-  {
-    if (udf->type == UDFTYPE_FUNCTION)
-    {
-      if (arg_count)
-        func= new (thd->mem_root) Item_func_udf_decimal(udf, *item_list);
-      else
-        func= new (thd->mem_root) Item_func_udf_decimal(udf);
-    }
-    else
-    {
-      if (arg_count)
-        func= new (thd->mem_root) Item_sum_udf_decimal(udf, *item_list);
-      else
-        func= new (thd->mem_root) Item_sum_udf_decimal(udf);
-    }
-    break;
-  }
-  default:
-  {
-    my_error(ER_NOT_SUPPORTED_YET, MYF(0), "UDF return type");
-  }
-  }
+  func= udf->create_func(thd->mem_root);
+
+  func->set_arguments(*item_list);
+
   return func;
 }
 

=== modified file 'drizzled/item_func.cc'
--- drizzled/item_func.cc	2008-09-25 14:20:40 +0000
+++ drizzled/item_func.cc	2008-09-26 11:21:06 +0000
@@ -2711,454 +2711,6 @@
   return (int64_t) my_count_bits(value);
 }
 
-
-/****************************************************************************
-** Functions to handle dynamic loadable functions
-** Original source by: Alexis Mikhailov <root@medinf.chuvashia.su>
-** Rewritten by monty.
-****************************************************************************/
-
-void udf_handler::cleanup()
-{
-  if (!not_original)
-  {
-    if (initialized)
-    {
-      if (u_d->func_deinit != NULL)
-      {
-        Udf_func_deinit deinit= u_d->func_deinit;
-        (*deinit)(&initid);
-      }
-
-      initialized= false;
-    }
-    if (buffers)				// Because of bug in ecc
-      delete [] buffers;
-    buffers= 0;
-  }
-}
-
-
-bool
-udf_handler::fix_fields(THD *thd, Item_result_field *func,
-			uint arg_count, Item **arguments)
-{
-  uchar buff[STACK_BUFF_ALLOC];			// Max argument in function
-
-  if (check_stack_overrun(thd, STACK_MIN_SIZE, buff))
-    return(true);				// Fatal error flag is set!
-
-  udf_func *tmp_udf=find_udf(u_d->name.str,(uint) u_d->name.length);
-
-  if (!tmp_udf)
-  {
-    my_error(ER_CANT_FIND_UDF, MYF(0), u_d->name.str, errno);
-    return(true);
-  }
-  u_d=tmp_udf;
-  args=arguments;
-
-  /* Fix all arguments */
-  func->maybe_null=0;
-  used_tables_cache=0;
-  const_item_cache=1;
-
-  if ((f_args.arg_count=arg_count))
-  {
-    if (!(f_args.arg_type= (Item_result*)
-	  sql_alloc(f_args.arg_count*sizeof(Item_result))))
-
-    {
-      return(true);
-    }
-    uint i;
-    Item **arg,**arg_end;
-    for (i=0, arg=arguments, arg_end=arguments+arg_count;
-	 arg != arg_end ;
-	 arg++,i++)
-    {
-      if (!(*arg)->fixed &&
-          (*arg)->fix_fields(thd, arg))
-	return(1);
-      // we can't assign 'item' before, because fix_fields() can change arg
-      Item *item= *arg;
-      if (item->check_cols(1))
-	return(true);
-      /*
-	TODO: We should think about this. It is not always
-	right way just to set an UDF result to return my_charset_bin
-	if one argument has binary sorting order.
-	The result collation should be calculated according to arguments
-	derivations in some cases and should not in other cases.
-	Moreover, some arguments can represent a numeric input
-	which doesn't effect the result character set and collation.
-	There is no a general rule for UDF. Everything depends on
-        the particular user defined function.
-      */
-      if (item->collation.collation->state & MY_CS_BINSORT)
-	func->collation.set(&my_charset_bin);
-      if (item->maybe_null)
-	func->maybe_null=1;
-      func->with_sum_func= func->with_sum_func || item->with_sum_func;
-      used_tables_cache|=item->used_tables();
-      const_item_cache&=item->const_item();
-      f_args.arg_type[i]=item->result_type();
-    }
-    //TODO: why all following memory is not allocated with 1 call of sql_alloc?
-    if (!(buffers=new String[arg_count]) ||
-	!(f_args.args= (char**) sql_alloc(arg_count * sizeof(char *))) ||
-	!(f_args.lengths= (ulong*) sql_alloc(arg_count * sizeof(long))) ||
-	!(f_args.maybe_null= (char*) sql_alloc(arg_count * sizeof(char))) ||
-	!(num_buffer= (char*) sql_alloc(arg_count *
-					ALIGN_SIZE(sizeof(double)))) ||
-	!(f_args.attributes= (char**) sql_alloc(arg_count * sizeof(char *))) ||
-	!(f_args.attribute_lengths= (ulong*) sql_alloc(arg_count *
-						       sizeof(long))))
-    {
-      return(true);
-    }
-  }
-  func->fix_length_and_dec();
-  initid.max_length=func->max_length;
-  initid.maybe_null=func->maybe_null;
-  initid.const_item=const_item_cache;
-  initid.decimals=func->decimals;
-  initid.ptr=0;
-
-  if (u_d->func_init)
-  {
-    char init_msg_buff[DRIZZLE_ERRMSG_SIZE];
-    char *to=num_buffer;
-    for (uint i=0; i < arg_count; i++)
-    {
-      /*
-       For a constant argument i, args->args[i] points to the argument value. 
-       For non-constant, args->args[i] is NULL.
-      */
-      f_args.args[i]= NULL;         /* Non-const unless updated below. */
-
-      f_args.lengths[i]= arguments[i]->max_length;
-      f_args.maybe_null[i]= (char) arguments[i]->maybe_null;
-      f_args.attributes[i]= arguments[i]->name;
-      f_args.attribute_lengths[i]= arguments[i]->name_length;
-
-      if (arguments[i]->const_item())
-      {
-        switch (arguments[i]->result_type()) 
-        {
-        case STRING_RESULT:
-        case DECIMAL_RESULT:
-        {
-          String *res= arguments[i]->val_str(&buffers[i]);
-          if (arguments[i]->null_value)
-            continue;
-          f_args.args[i]= (char*) res->c_ptr();
-          f_args.lengths[i]= res->length();
-          break;
-        }
-        case INT_RESULT:
-          *((int64_t*) to)= arguments[i]->val_int();
-          if (arguments[i]->null_value)
-            continue;
-          f_args.args[i]= to;
-          to+= ALIGN_SIZE(sizeof(int64_t));
-          break;
-        case REAL_RESULT:
-          *((double*) to)= arguments[i]->val_real();
-          if (arguments[i]->null_value)
-            continue;
-          f_args.args[i]= to;
-          to+= ALIGN_SIZE(sizeof(double));
-          break;
-        case ROW_RESULT:
-        default:
-          // This case should never be chosen
-          assert(0);
-          break;
-        }
-      }
-    }
-    Udf_func_init init= u_d->func_init;
-    if ((error=(uchar) init(&initid, &f_args, init_msg_buff)))
-    {
-      my_error(ER_CANT_INITIALIZE_UDF, MYF(0),
-               u_d->name.str, init_msg_buff);
-      return(true);
-    }
-    func->max_length=min(initid.max_length,(unsigned long)MAX_BLOB_WIDTH);
-    func->maybe_null=initid.maybe_null;
-    const_item_cache=initid.const_item;
-    /* 
-      Keep used_tables_cache in sync with const_item_cache.
-      See the comment in Item_udf_func::update_used tables.
-    */  
-    if (!const_item_cache && !used_tables_cache)
-      used_tables_cache= RAND_TABLE_BIT;
-    func->decimals=min(initid.decimals,(unsigned int)NOT_FIXED_DEC);
-  }
-  initialized=1;
-  if (error)
-  {
-    my_error(ER_CANT_INITIALIZE_UDF, MYF(0),
-             u_d->name.str, ER(ER_UNKNOWN_ERROR));
-    return(true);
-  }
-  return(false);
-}
-
-
-bool udf_handler::get_arguments()
-{
-  if (error)
-    return 1;					// Got an error earlier
-  char *to= num_buffer;
-  uint str_count=0;
-  for (uint i=0; i < f_args.arg_count; i++)
-  {
-    f_args.args[i]=0;
-    switch (f_args.arg_type[i]) {
-    case STRING_RESULT:
-    case DECIMAL_RESULT:
-      {
-	String *res=args[i]->val_str(&buffers[str_count++]);
-	if (!(args[i]->null_value))
-	{
-	  f_args.args[i]=    (char*) res->ptr();
-	  f_args.lengths[i]= res->length();
-	  break;
-	}
-      }
-    case INT_RESULT:
-      *((int64_t*) to) = args[i]->val_int();
-      if (!args[i]->null_value)
-      {
-	f_args.args[i]=to;
-	to+= ALIGN_SIZE(sizeof(int64_t));
-      }
-      break;
-    case REAL_RESULT:
-      *((double*) to)= args[i]->val_real();
-      if (!args[i]->null_value)
-      {
-	f_args.args[i]=to;
-	to+= ALIGN_SIZE(sizeof(double));
-      }
-      break;
-    case ROW_RESULT:
-    default:
-      // This case should never be chosen
-      assert(0);
-      break;
-    }
-  }
-  return 0;
-}
-
-/**
-  @return
-    (String*)NULL in case of NULL values
-*/
-String *udf_handler::val_str(String *str,String *save_str)
-{
-  uchar is_null_tmp=0;
-  ulong res_length;
-
-  if (get_arguments())
-    return(0);
-  char * (*func)(UDF_INIT *, UDF_ARGS *, char *, ulong *, uchar *, uchar *)=
-    (char* (*)(UDF_INIT *, UDF_ARGS *, char *, ulong *, uchar *, uchar *))
-    u_d->func;
-
-  if ((res_length=str->alloced_length()) < MAX_FIELD_WIDTH)
-  {						// This happens VERY seldom
-    if (str->alloc(MAX_FIELD_WIDTH))
-    {
-      error=1;
-      return(0);
-    }
-  }
-  char *res=func(&initid, &f_args, (char*) str->ptr(), &res_length,
-		 &is_null_tmp, &error);
-  if (is_null_tmp || !res || error)		// The !res is for safety
-  {
-    return(0);
-  }
-  if (res == str->ptr())
-  {
-    str->length(res_length);
-    return(str);
-  }
-  save_str->set(res, res_length, str->charset());
-  return(save_str);
-}
-
-
-/*
-  For the moment, UDF functions are returning DECIMAL values as strings
-*/
-
-my_decimal *udf_handler::val_decimal(bool *null_value, my_decimal *dec_buf)
-{
-  char buf[DECIMAL_MAX_STR_LENGTH+1], *end;
-  ulong res_length= DECIMAL_MAX_STR_LENGTH;
-
-  if (get_arguments())
-  {
-    *null_value=1;
-    return 0;
-  }
-  char *(*func)(UDF_INIT *, UDF_ARGS *, char *, ulong *, uchar *, uchar *)=
-    (char* (*)(UDF_INIT *, UDF_ARGS *, char *, ulong *, uchar *, uchar *))
-    u_d->func;
-
-  char *res= func(&initid, &f_args, buf, &res_length, &is_null, &error);
-  if (is_null || error)
-  {
-    *null_value= 1;
-    return 0;
-  }
-  end= res+ res_length;
-  str2my_decimal(E_DEC_FATAL_ERROR, res, dec_buf, &end);
-  return dec_buf;
-}
-
-
-void Item_udf_func::cleanup()
-{
-  udf.cleanup();
-  Item_func::cleanup();
-}
-
-
-void Item_udf_func::print(String *str, enum_query_type query_type)
-{
-  str->append(func_name());
-  str->append('(');
-  for (uint i=0 ; i < arg_count ; i++)
-  {
-    if (i != 0)
-      str->append(',');
-    args[i]->print_item_w_name(str, query_type);
-  }
-  str->append(')');
-}
-
-
-double Item_func_udf_float::val_real()
-{
-  assert(fixed == 1);
-  return(udf.val(&null_value));
-}
-
-
-String *Item_func_udf_float::val_str(String *str)
-{
-  assert(fixed == 1);
-  double nr= val_real();
-  if (null_value)
-    return 0;					/* purecov: inspected */
-  str->set_real(nr,decimals,&my_charset_bin);
-  return str;
-}
-
-
-int64_t Item_func_udf_int::val_int()
-{
-  assert(fixed == 1);
-  return(udf.val_int(&null_value));
-}
-
-
-String *Item_func_udf_int::val_str(String *str)
-{
-  assert(fixed == 1);
-  int64_t nr=val_int();
-  if (null_value)
-    return 0;
-  str->set_int(nr, unsigned_flag, &my_charset_bin);
-  return str;
-}
-
-
-int64_t Item_func_udf_decimal::val_int()
-{
-  my_decimal dec_buf, *dec= udf.val_decimal(&null_value, &dec_buf);
-  int64_t result;
-  if (null_value)
-    return 0;
-  my_decimal2int(E_DEC_FATAL_ERROR, dec, unsigned_flag, &result);
-  return result;
-}
-
-
-double Item_func_udf_decimal::val_real()
-{
-  my_decimal dec_buf, *dec= udf.val_decimal(&null_value, &dec_buf);
-  double result;
-  if (null_value)
-    return 0.0;
-  my_decimal2double(E_DEC_FATAL_ERROR, dec, &result);
-  return result;
-}
-
-
-my_decimal *Item_func_udf_decimal::val_decimal(my_decimal *dec_buf)
-{
-  assert(fixed == 1);
-  return(udf.val_decimal(&null_value, dec_buf));
-}
-
-
-String *Item_func_udf_decimal::val_str(String *str)
-{
-  my_decimal dec_buf, *dec= udf.val_decimal(&null_value, &dec_buf);
-  if (null_value)
-    return 0;
-  if (str->length() < DECIMAL_MAX_STR_LENGTH)
-    str->length(DECIMAL_MAX_STR_LENGTH);
-  my_decimal_round(E_DEC_FATAL_ERROR, dec, decimals, false, &dec_buf);
-  my_decimal2string(E_DEC_FATAL_ERROR, &dec_buf, 0, 0, '0', str);
-  return str;
-}
-
-
-void Item_func_udf_decimal::fix_length_and_dec()
-{
-  fix_num_length_and_dec();
-}
-
-
-/* Default max_length is max argument length */
-
-void Item_func_udf_str::fix_length_and_dec()
-{
-  max_length=0;
-  for (uint i = 0; i < arg_count; i++)
-    set_if_bigger(max_length,args[i]->max_length);
-  return;
-}
-
-String *Item_func_udf_str::val_str(String *str)
-{
-  assert(fixed == 1);
-  String *res=udf.val_str(str,&str_value);
-  null_value = !res;
-  return res;
-}
-
-
-/**
-  @note
-  This has to come last in the udf_handler methods, or C for AIX
-  version 6.0.0.0 fails to compile with debugging enabled. (Yes, really.)
-*/
-
-udf_handler::~udf_handler()
-{
-  /* Everything should be properly cleaned up by this moment. */
-  assert(not_original || !(initialized || buffers));
-}
-
 /*
 ** User level locks
 */

=== modified file 'drizzled/item_func.h'
--- drizzled/item_func.h	2008-09-16 00:00:48 +0000
+++ drizzled/item_func.h	2008-09-25 08:57:27 +0000
@@ -55,7 +55,7 @@
                   NOT_FUNC, NOT_ALL_FUNC,
                   NOW_FUNC, TRIG_COND_FUNC,
                   SUSERVAR_FUNC, GUSERVAR_FUNC, COLLATE_FUNC,
-                  EXTRACT_FUNC, CHAR_TYPECAST_FUNC, FUNC_SP, UDF_FUNC,
+                  EXTRACT_FUNC, CHAR_TYPECAST_FUNC, FUNC_SP,
                   NEG_FUNC };
   enum optimize_type { OPTIMIZE_NONE,OPTIMIZE_KEY,OPTIMIZE_OP, OPTIMIZE_NULL,
                        OPTIMIZE_EQUAL };
@@ -136,7 +136,7 @@
     {Sum}Functype and Item_func::functype()/Item_sum::sum_func()
     instead.
   */
-  virtual const char *func_name() const= 0;
+  virtual const char *func_name() const { return NULL; };
   virtual bool const_item() const { return const_item_cache; }
   inline Item **arguments() const { return args; }
   void set_arguments(List<Item> &list);
@@ -163,7 +163,7 @@
     return null_value; 
   }
   void signal_divide_by_null();
-  friend class udf_handler;
+
   Field *tmp_table_field() { return result_field; }
   Field *tmp_table_field(Table *t_arg);
   Item *get_tmp_table_item(THD *thd);
@@ -992,183 +992,6 @@
   virtual void print(String *str, enum_query_type query_type);
 };
 
-
-class Item_udf_func :public Item_func
-{
-protected:
-  udf_handler udf;
-  bool is_expensive_processor(uchar *arg __attribute__((unused)))
-  { return true; }
-
-public:
-  Item_udf_func(udf_func *udf_arg)
-    :Item_func(), udf(udf_arg) {}
-  Item_udf_func(udf_func *udf_arg, List<Item> &list)
-    :Item_func(list), udf(udf_arg) {}
-  const char *func_name() const { return udf.name(); }
-  enum Functype functype() const   { return UDF_FUNC; }
-  bool fix_fields(THD *thd, Item **ref __attribute__((unused)))
-  {
-    assert(fixed == 0);
-    bool res= udf.fix_fields(thd, this, arg_count, args);
-    used_tables_cache= udf.used_tables_cache;
-    const_item_cache= udf.const_item_cache;
-    fixed= 1;
-    return res;
-  }
-  void update_used_tables() 
-  {
-    /*
-      TODO: Make a member in UDF_INIT and return if a UDF is deterministic or
-      not.
-      Currently UDF_INIT has a member (const_item) that is an in/out 
-      parameter to the init() call.
-      The code in udf_handler::fix_fields also duplicates the arguments 
-      handling code in Item_func::fix_fields().
-      
-      The lack of information if a UDF is deterministic makes writing
-      a correct update_used_tables() for UDFs impossible.
-      One solution to this would be :
-       - Add a is_deterministic member of UDF_INIT
-       - (optionally) deprecate the const_item member of UDF_INIT
-       - Take away the duplicate code from udf_handler::fix_fields() and
-         make Item_udf_func call Item_func::fix_fields() to process its 
-         arguments as for any other function.
-       - Store the deterministic flag returned by <udf>_init into the 
-       udf_handler. 
-       - Don't implement Item_udf_func::fix_fields, implement
-       Item_udf_func::fix_length_and_dec() instead (similar to non-UDF
-       functions).
-       - Override Item_func::update_used_tables to call 
-       Item_func::update_used_tables() and add a RAND_TABLE_BIT to the 
-       result of Item_func::update_used_tables() if the UDF is 
-       non-deterministic.
-       - (optionally) rename RAND_TABLE_BIT to NONDETERMINISTIC_BIT to
-       better describe its usage.
-       
-      The above would require a change of the UDF API.
-      Until that change is done here's how the current code works:
-      We call Item_func::update_used_tables() only when we know that
-      the function depends on real non-const tables and is deterministic.
-      This can be done only because we know that the optimizer will
-      call update_used_tables() only when there's possibly a new const
-      table. So update_used_tables() can only make a Item_func more
-      constant than it is currently.
-      That's why we don't need to do anything if a function is guaranteed
-      to return non-constant (it's non-deterministic) or is already a
-      const.
-    */  
-    if ((used_tables_cache & ~PSEUDO_TABLE_BITS) && 
-        !(used_tables_cache & RAND_TABLE_BIT))
-    {
-      Item_func::update_used_tables();
-      if (!const_item_cache && !used_tables_cache)
-        used_tables_cache= RAND_TABLE_BIT;
-    }
-  }
-  void cleanup();
-  Item_result result_type () const { return udf.result_type(); }
-  table_map not_null_tables() const { return 0; }
-  virtual void print(String *str, enum_query_type query_type);
-};
-
-
-class Item_func_udf_float :public Item_udf_func
-{
- public:
-  Item_func_udf_float(udf_func *udf_arg)
-    :Item_udf_func(udf_arg) {}
-  Item_func_udf_float(udf_func *udf_arg,
-                      List<Item> &list)
-    :Item_udf_func(udf_arg, list) {}
-  int64_t val_int()
-  {
-    assert(fixed == 1);
-    return (int64_t) rint(Item_func_udf_float::val_real());
-  }
-  my_decimal *val_decimal(my_decimal *dec_buf)
-  {
-    double res=val_real();
-    if (null_value)
-      return NULL;
-    double2my_decimal(E_DEC_FATAL_ERROR, res, dec_buf);
-    return dec_buf;
-  }
-  double val_real();
-  String *val_str(String *str);
-  void fix_length_and_dec() { fix_num_length_and_dec(); }
-};
-
-
-class Item_func_udf_int :public Item_udf_func
-{
-public:
-  Item_func_udf_int(udf_func *udf_arg)
-    :Item_udf_func(udf_arg) {}
-  Item_func_udf_int(udf_func *udf_arg,
-                    List<Item> &list)
-    :Item_udf_func(udf_arg, list) {}
-  int64_t val_int();
-  double val_real() { return (double) Item_func_udf_int::val_int(); }
-  String *val_str(String *str);
-  enum Item_result result_type () const { return INT_RESULT; }
-  void fix_length_and_dec() { decimals= 0; max_length= 21; }
-};
-
-
-class Item_func_udf_decimal :public Item_udf_func
-{
-public:
-  Item_func_udf_decimal(udf_func *udf_arg)
-    :Item_udf_func(udf_arg) {}
-  Item_func_udf_decimal(udf_func *udf_arg, List<Item> &list)
-    :Item_udf_func(udf_arg, list) {}
-  int64_t val_int();
-  double val_real();
-  my_decimal *val_decimal(my_decimal *);
-  String *val_str(String *str);
-  enum Item_result result_type () const { return DECIMAL_RESULT; }
-  void fix_length_and_dec();
-};
-
-
-class Item_func_udf_str :public Item_udf_func
-{
-public:
-  Item_func_udf_str(udf_func *udf_arg)
-    :Item_udf_func(udf_arg) {}
-  Item_func_udf_str(udf_func *udf_arg, List<Item> &list)
-    :Item_udf_func(udf_arg, list) {}
-  String *val_str(String *);
-  double val_real()
-  {
-    int err_not_used;
-    char *end_not_used;
-    String *res;
-    res= val_str(&str_value);
-    return res ? my_strntod(res->charset(),(char*) res->ptr(), 
-                            res->length(), &end_not_used, &err_not_used) : 0.0;
-  }
-  int64_t val_int()
-  {
-    int err_not_used;
-    String *res;  res=val_str(&str_value);
-    return res ? my_strntoll(res->charset(),res->ptr(),res->length(),10,
-                             (char**) 0, &err_not_used) : (int64_t) 0;
-  }
-  my_decimal *val_decimal(my_decimal *dec_buf)
-  {
-    String *res=val_str(&str_value);
-    if (!res)
-      return NULL;
-    string2my_decimal(E_DEC_FATAL_ERROR, res, dec_buf);
-    return dec_buf;
-  }
-  enum Item_result result_type () const { return STRING_RESULT; }
-  void fix_length_and_dec();
-};
-
-
 /* replication functions */
 
 class Item_master_pos_wait :public Item_int_func

=== modified file 'drizzled/item_strfunc.cc'
--- drizzled/item_strfunc.cc	2008-09-08 05:34:16 +0000
+++ drizzled/item_strfunc.cc	2008-09-25 10:04:06 +0000
@@ -2489,148 +2489,6 @@
   return 0;
 }
 
-int64_t Item_func_uncompressed_length::val_int()
-{
-  assert(fixed == 1);
-  String *res= args[0]->val_str(&value);
-  if (!res)
-  {
-    null_value=1;
-    return 0; /* purecov: inspected */
-  }
-  null_value=0;
-  if (res->is_empty()) return 0;
-
-  /*
-    res->ptr() using is safe because we have tested that string is not empty,
-    res->c_ptr() is not used because:
-      - we do not need \0 terminated string to get first 4 bytes
-      - c_ptr() tests simbol after string end (uninitialiozed memory) which
-        confuse valgrind
-  */
-  return uint4korr(res->ptr()) & 0x3FFFFFFF;
-}
-
-#ifdef HAVE_COMPRESS
-#include "zlib.h"
-
-String *Item_func_compress::val_str(String *str)
-{
-  int err= Z_OK, code;
-  ulong new_size;
-  String *res;
-  Byte *body;
-  char *tmp, *last_char;
-  assert(fixed == 1);
-
-  if (!(res= args[0]->val_str(str)))
-  {
-    null_value= 1;
-    return 0;
-  }
-  null_value= 0;
-  if (res->is_empty()) return res;
-
-  /*
-    Citation from zlib.h (comment for compress function):
-
-    Compresses the source buffer into the destination buffer.  sourceLen is
-    the byte length of the source buffer. Upon entry, destLen is the total
-    size of the destination buffer, which must be at least 0.1% larger than
-    sourceLen plus 12 bytes.
-    We assume here that the buffer can't grow more than .25 %.
-  */
-  new_size= res->length() + res->length() / 5 + 12;
-
-  // Check new_size overflow: new_size <= res->length()
-  if (((uint32_t) (new_size+5) <= res->length()) || 
-      buffer.realloc((uint32_t) new_size + 4 + 1))
-  {
-    null_value= 1;
-    return 0;
-  }
-
-  body= ((Byte*)buffer.ptr()) + 4;
-
-  // As far as we have checked res->is_empty() we can use ptr()
-  if ((err= compress(body, &new_size,
-		     (const Bytef*)res->ptr(), res->length())) != Z_OK)
-  {
-    code= err==Z_MEM_ERROR ? ER_ZLIB_Z_MEM_ERROR : ER_ZLIB_Z_BUF_ERROR;
-    push_warning(current_thd, DRIZZLE_ERROR::WARN_LEVEL_ERROR, code, ER(code));
-    null_value= 1;
-    return 0;
-  }
-
-  tmp= (char*)buffer.ptr(); // int4store is a macro; avoid side effects
-  int4store(tmp, res->length() & 0x3FFFFFFF);
-
-  /* This is to ensure that things works for CHAR fields, which trim ' ': */
-  last_char= ((char*)body)+new_size-1;
-  if (*last_char == ' ')
-  {
-    *++last_char= '.';
-    new_size++;
-  }
-
-  buffer.length((uint32_t)new_size + 4);
-  return &buffer;
-}
-
-
-String *Item_func_uncompress::val_str(String *str)
-{
-  assert(fixed == 1);
-  String *res= args[0]->val_str(str);
-  ulong new_size;
-  int err;
-  uint code;
-
-  if (!res)
-    goto err;
-  null_value= 0;
-  if (res->is_empty())
-    return res;
-
-  /* If length is less than 4 bytes, data is corrupt */
-  if (res->length() <= 4)
-  {
-    push_warning_printf(current_thd, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
-			ER_ZLIB_Z_DATA_ERROR,
-			ER(ER_ZLIB_Z_DATA_ERROR));
-    goto err;
-  }
-
-  /* Size of uncompressed data is stored as first 4 bytes of field */
-  new_size= uint4korr(res->ptr()) & 0x3FFFFFFF;
-  if (new_size > current_thd->variables.max_allowed_packet)
-  {
-    push_warning_printf(current_thd, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
-			ER_TOO_BIG_FOR_UNCOMPRESS,
-			ER(ER_TOO_BIG_FOR_UNCOMPRESS),
-                        current_thd->variables.max_allowed_packet);
-    goto err;
-  }
-  if (buffer.realloc((uint32_t)new_size))
-    goto err;
-
-  if ((err= uncompress((Byte*)buffer.ptr(), &new_size,
-		       ((const Bytef*)res->ptr())+4,res->length())) == Z_OK)
-  {
-    buffer.length((uint32_t) new_size);
-    return &buffer;
-  }
-
-  code= ((err == Z_BUF_ERROR) ? ER_ZLIB_Z_BUF_ERROR :
-	 ((err == Z_MEM_ERROR) ? ER_ZLIB_Z_MEM_ERROR : ER_ZLIB_Z_DATA_ERROR));
-  push_warning(current_thd, DRIZZLE_ERROR::WARN_LEVEL_ERROR, code, ER(code));
-
-err:
-  null_value= 1;
-  return 0;
-}
-#endif
-
 /*
   UUID, as in
     DCE 1.1: Remote Procedure Call,

=== modified file 'drizzled/item_strfunc.h'
--- drizzled/item_strfunc.h	2008-09-16 00:00:48 +0000
+++ drizzled/item_strfunc.h	2008-09-25 10:04:06 +0000
@@ -620,42 +620,6 @@
   void fix_length_and_dec();
 };
 
-class Item_func_uncompressed_length : public Item_int_func
-{
-  String value;
-public:
-  Item_func_uncompressed_length(Item *a):Item_int_func(a){}
-  const char *func_name() const{return "uncompressed_length";}
-  void fix_length_and_dec() { max_length=10; }
-  int64_t val_int();
-};
-
-#ifdef HAVE_COMPRESS
-#define ZLIB_DEPENDED_FUNCTION ;
-#else
-#define ZLIB_DEPENDED_FUNCTION { null_value=1; return 0; }
-#endif
-
-class Item_func_compress: public Item_str_func
-{
-  String buffer;
-public:
-  Item_func_compress(Item *a):Item_str_func(a){}
-  void fix_length_and_dec(){max_length= (args[0]->max_length*120)/100+12;}
-  const char *func_name() const{return "compress";}
-  String *val_str(String *) ZLIB_DEPENDED_FUNCTION
-};
-
-class Item_func_uncompress: public Item_str_func
-{
-  String buffer;
-public:
-  Item_func_uncompress(Item *a): Item_str_func(a){}
-  void fix_length_and_dec(){ maybe_null= 1; max_length= MAX_BLOB_WIDTH; }
-  const char *func_name() const{return "uncompress";}
-  String *val_str(String *) ZLIB_DEPENDED_FUNCTION
-};
-
 #define UUID_LENGTH (8+1+4+1+4+1+4+1+12)
 class Item_func_uuid: public Item_str_func
 {

=== modified file 'drizzled/item_sum.cc'
--- drizzled/item_sum.cc	2008-09-25 14:20:40 +0000
+++ drizzled/item_sum.cc	2008-09-26 11:21:06 +0000
@@ -2715,159 +2715,6 @@
   return table->file->stats.records;
 }
 
-
-/****************************************************************************
-** Functions to handle dynamic loadable aggregates
-** Original source by: Alexis Mikhailov <root@medinf.chuvashia.su>
-** Adapted for UDAs by: Andreas F. Bobak <bobak@relog.ch>.
-** Rewritten by: Monty.
-****************************************************************************/
-
-void Item_udf_sum::clear()
-{
-  udf.clear();
-  return;
-}
-
-bool Item_udf_sum::add()
-{
-  udf.add(&null_value);
-  return(0);
-}
-
-void Item_udf_sum::cleanup()
-{
-  /*
-    udf_handler::cleanup() nicely handles case when we have not
-    original item but one created by copy_or_same() method.
-  */
-  udf.cleanup();
-  Item_sum::cleanup();
-}
-
-
-void Item_udf_sum::print(String *str, enum_query_type query_type)
-{
-  str->append(func_name());
-  str->append('(');
-  for (uint i=0 ; i < arg_count ; i++)
-  {
-    if (i)
-      str->append(',');
-    args[i]->print(str, query_type);
-  }
-  str->append(')');
-}
-
-
-Item *Item_sum_udf_float::copy_or_same(THD* thd)
-{
-  return new (thd->mem_root) Item_sum_udf_float(thd, this);
-}
-
-double Item_sum_udf_float::val_real()
-{
-  assert(fixed == 1);
-  return(udf.val(&null_value));
-}
-
-
-String *Item_sum_udf_float::val_str(String *str)
-{
-  return val_string_from_real(str);
-}
-
-
-my_decimal *Item_sum_udf_float::val_decimal(my_decimal *dec)
-{
-  return val_decimal_from_real(dec);
-}
-
-
-String *Item_sum_udf_decimal::val_str(String *str)
-{
-  return val_string_from_decimal(str);
-}
-
-
-double Item_sum_udf_decimal::val_real()
-{
-  return val_real_from_decimal();
-}
-
-
-int64_t Item_sum_udf_decimal::val_int()
-{
-  return val_int_from_decimal();
-}
-
-
-my_decimal *Item_sum_udf_decimal::val_decimal(my_decimal *dec_buf)
-{
-  assert(fixed == 1);
-  return(udf.val_decimal(&null_value, dec_buf));
-}
-
-
-Item *Item_sum_udf_decimal::copy_or_same(THD* thd)
-{
-  return new (thd->mem_root) Item_sum_udf_decimal(thd, this);
-}
-
-
-Item *Item_sum_udf_int::copy_or_same(THD* thd)
-{
-  return new (thd->mem_root) Item_sum_udf_int(thd, this);
-}
-
-int64_t Item_sum_udf_int::val_int()
-{
-  assert(fixed == 1);
-  return(udf.val_int(&null_value));
-}
-
-
-String *Item_sum_udf_int::val_str(String *str)
-{
-  return val_string_from_int(str);
-}
-
-my_decimal *Item_sum_udf_int::val_decimal(my_decimal *dec)
-{
-  return val_decimal_from_int(dec);
-}
-
-
-/** Default max_length is max argument length. */
-
-void Item_sum_udf_str::fix_length_and_dec()
-{
-  max_length=0;
-  for (uint i = 0; i < arg_count; i++)
-    set_if_bigger(max_length,args[i]->max_length);
-  return;
-}
-
-
-Item *Item_sum_udf_str::copy_or_same(THD* thd)
-{
-  return new (thd->mem_root) Item_sum_udf_str(thd, this);
-}
-
-
-my_decimal *Item_sum_udf_str::val_decimal(my_decimal *dec)
-{
-  return val_decimal_from_string(dec);
-}
-
-String *Item_sum_udf_str::val_str(String *str)
-{
-  assert(fixed == 1);
-  String *res=udf.val_str(str,&str_value);
-  null_value = !res;
-  return(res);
-}
-
 /*****************************************************************************
  GROUP_CONCAT function
 

=== modified file 'drizzled/item_sum.h'
--- drizzled/item_sum.h	2008-09-16 00:00:48 +0000
+++ drizzled/item_sum.h	2008-09-25 08:57:27 +0000
@@ -229,7 +229,7 @@
   enum Sumfunctype
   { COUNT_FUNC, COUNT_DISTINCT_FUNC, SUM_FUNC, SUM_DISTINCT_FUNC, AVG_FUNC,
     AVG_DISTINCT_FUNC, MIN_FUNC, MAX_FUNC, STD_FUNC,
-    VARIANCE_FUNC, SUM_BIT_FUNC, UDF_SUM_FUNC, GROUP_CONCAT_FUNC
+    VARIANCE_FUNC, SUM_BIT_FUNC, GROUP_CONCAT_FUNC
   };
 
   Item **args, *tmp_args[2];
@@ -952,149 +952,6 @@
 };
 
 
-/*
-  User defined aggregates
-*/
-
-class Item_udf_sum : public Item_sum
-{
-protected:
-  udf_handler udf;
-
-public:
-  Item_udf_sum(udf_func *udf_arg)
-    :Item_sum(), udf(udf_arg)
-  { quick_group=0; }
-  Item_udf_sum(udf_func *udf_arg, List<Item> &list)
-    :Item_sum(list), udf(udf_arg)
-  { quick_group=0;}
-  Item_udf_sum(THD *thd, Item_udf_sum *item)
-    :Item_sum(thd, item), udf(item->udf)
-  { udf.not_original= true; }
-  const char *func_name() const { return udf.name(); }
-  bool fix_fields(THD *thd, Item **ref)
-  {
-    assert(fixed == 0);
-
-    if (init_sum_func_check(thd))
-      return true;
-
-    fixed= 1;
-    if (udf.fix_fields(thd, this, this->arg_count, this->args))
-      return true;
-
-    return check_sum_func(thd, ref);
-  }
-  enum Sumfunctype sum_func () const { return UDF_SUM_FUNC; }
-  virtual bool have_field_update(void) const { return 0; }
-
-  void clear();
-  bool add();
-  void reset_field() {};
-  void update_field() {};
-  void cleanup();
-  virtual void print(String *str, enum_query_type query_type);
-};
-
-
-class Item_sum_udf_float :public Item_udf_sum
-{
- public:
-  Item_sum_udf_float(udf_func *udf_arg)
-    :Item_udf_sum(udf_arg) {}
-  Item_sum_udf_float(udf_func *udf_arg, List<Item> &list)
-    :Item_udf_sum(udf_arg, list) {}
-  Item_sum_udf_float(THD *thd, Item_sum_udf_float *item)
-    :Item_udf_sum(thd, item) {}
-  int64_t val_int()
-  {
-    assert(fixed == 1);
-    return (int64_t) rint(Item_sum_udf_float::val_real());
-  }
-  double val_real();
-  String *val_str(String*str);
-  my_decimal *val_decimal(my_decimal *);
-  void fix_length_and_dec() { fix_num_length_and_dec(); }
-  Item *copy_or_same(THD* thd);
-};
-
-
-class Item_sum_udf_int :public Item_udf_sum
-{
-public:
-  Item_sum_udf_int(udf_func *udf_arg)
-    :Item_udf_sum(udf_arg) {}
-  Item_sum_udf_int(udf_func *udf_arg, List<Item> &list)
-    :Item_udf_sum(udf_arg, list) {}
-  Item_sum_udf_int(THD *thd, Item_sum_udf_int *item)
-    :Item_udf_sum(thd, item) {}
-  int64_t val_int();
-  double val_real()
-    { assert(fixed == 1); return (double) Item_sum_udf_int::val_int(); }
-  String *val_str(String*str);
-  my_decimal *val_decimal(my_decimal *);
-  enum Item_result result_type () const { return INT_RESULT; }
-  void fix_length_and_dec() { decimals=0; max_length=21; }
-  Item *copy_or_same(THD* thd);
-};
-
-
-class Item_sum_udf_str :public Item_udf_sum
-{
-public:
-  Item_sum_udf_str(udf_func *udf_arg)
-    :Item_udf_sum(udf_arg) {}
-  Item_sum_udf_str(udf_func *udf_arg, List<Item> &list)
-    :Item_udf_sum(udf_arg,list) {}
-  Item_sum_udf_str(THD *thd, Item_sum_udf_str *item)
-    :Item_udf_sum(thd, item) {}
-  String *val_str(String *);
-  double val_real()
-  {
-    int err_not_used;
-    char *end_not_used;
-    String *res;
-    res=val_str(&str_value);
-    return res ? my_strntod(res->charset(),(char*) res->ptr(),res->length(),
-			    &end_not_used, &err_not_used) : 0.0;
-  }
-  int64_t val_int()
-  {
-    int err_not_used;
-    char *end;
-    String *res;
-    const CHARSET_INFO *cs;
-
-    if (!(res= val_str(&str_value)))
-      return 0;                                 /* Null value */
-    cs= res->charset();
-    end= (char*) res->ptr()+res->length();
-    return cs->cset->strtoll10(cs, res->ptr(), &end, &err_not_used);
-  }
-  my_decimal *val_decimal(my_decimal *dec);
-  enum Item_result result_type () const { return STRING_RESULT; }
-  void fix_length_and_dec();
-  Item *copy_or_same(THD* thd);
-};
-
-
-class Item_sum_udf_decimal :public Item_udf_sum
-{
-public:
-  Item_sum_udf_decimal(udf_func *udf_arg)
-    :Item_udf_sum(udf_arg) {}
-  Item_sum_udf_decimal(udf_func *udf_arg, List<Item> &list)
-    :Item_udf_sum(udf_arg, list) {}
-  Item_sum_udf_decimal(THD *thd, Item_sum_udf_decimal *item)
-    :Item_udf_sum(thd, item) {}
-  String *val_str(String *);
-  double val_real();
-  int64_t val_int();
-  my_decimal *val_decimal(my_decimal *);
-  enum Item_result result_type () const { return DECIMAL_RESULT; }
-  void fix_length_and_dec() { fix_num_length_and_dec(); }
-  Item *copy_or_same(THD* thd);
-};
 
 class DRIZZLE_ERROR;
 

=== modified file 'drizzled/sql_class.h'
--- drizzled/sql_class.h	2008-09-25 21:45:57 +0000
+++ drizzled/sql_class.h	2008-09-26 11:21:06 +0000
@@ -232,8 +232,6 @@
   LEX_COLUMN (const String& x,const  uint& y ): column (x),rights (y) {}
 };
 
-#include "sql_lex.h"				/* Must be here */
-
 class select_result;
 class Time_zone;
 
@@ -359,6 +357,7 @@
 
 };
 
+#include "sql_lex.h"  /* only for SQLCOM_END */
 
 /* per thread status variables */
 

=== modified file 'drizzled/sql_lex.h'
--- drizzled/sql_lex.h	2008-09-25 15:52:56 +0000
+++ drizzled/sql_lex.h	2008-09-26 11:21:06 +0000
@@ -24,6 +24,8 @@
   @defgroup Semantic_Analysis Semantic Analysis
 */
 
+#include "sql_udf.h"
+
 /* YACC and LEX Definitions */
 
 /* These may not be declared yet */

=== modified file 'drizzled/sql_plugin.cc'
--- drizzled/sql_plugin.cc	2008-09-08 05:34:16 +0000
+++ drizzled/sql_plugin.cc	2008-09-25 08:57:27 +0000
@@ -342,7 +342,7 @@
     dlpath;
   plugin_dl.ref_count= 1;
   /* Open new dll handle */
-  if (!(plugin_dl.handle= dlopen(dlpath, RTLD_NOW)))
+  if (!(plugin_dl.handle= dlopen(dlpath, RTLD_LAZY|RTLD_GLOBAL)))
   {
     const char *errmsg=dlerror();
     if (!strncmp(dlpath, errmsg, dlpathlen))

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2008-08-20 04:57:36 +0000
+++ drizzled/sql_table.cc	2008-09-26 23:31:37 +0000
@@ -4000,8 +4000,6 @@
   }
   if (!(used_fields & HA_CREATE_USED_KEY_BLOCK_SIZE))
     create_info->key_block_size= table->s->key_block_size;
-  if (!(used_fields & HA_CREATE_USED_TRANSACTIONAL))
-    create_info->transactional= table->s->transactional;
 
   restore_record(table, s->default_values);     // Empty record for DEFAULT
   Create_field *def;

=== modified file 'drizzled/sql_udf.cc'
--- drizzled/sql_udf.cc	2008-08-16 23:47:43 +0000
+++ drizzled/sql_udf.cc	2008-09-25 08:57:27 +0000
@@ -77,38 +77,32 @@
 
 int initialize_udf(st_plugin_int *plugin)
 {
-  udf_func *udff;
+  udf_func *f;
 
   if (udf_startup == false)
   {
     udf_init();
     udf_startup= true;
   }
-	  
-  /* allocate the udf_func structure */
-  udff = (udf_func *)my_malloc(sizeof(udf_func), MYF(MY_WME | MY_ZEROFILL));
-  if (udff == NULL) return 1;
-
-  plugin->data= (void *)udff;
 
   if (plugin->plugin->init)
   {
-    /* todo, if the plugin doesnt have an init, bail out */
-
-    if (plugin->plugin->init((void *)udff))
+    int r;
+    if ((r= plugin->plugin->init((void *)&f)))
     {
-      sql_print_error(_("Plugin '%s' init function returned error."),
-                      plugin->name.str);
-      goto err;
+      sql_print_error("Plugin '%s' init function returned error %d.",
+                      plugin->name.str, r);
+      return r;
     }
   }
-  
-  add_udf(udff);
+  else
+    return 1;
+
+  if(!add_udf(f))
+    return 2;
 
   return 0;
-err:
-  my_free(udff, MYF(0));
-  return 1;
+
 }
 
 int finalize_udf(st_plugin_int *plugin)

=== modified file 'drizzled/sql_udf.h'
--- drizzled/sql_udf.h	2008-09-16 00:00:48 +0000
+++ drizzled/sql_udf.h	2008-09-25 08:57:27 +0000
@@ -23,117 +23,18 @@
 #pragma interface
 #endif
 
+#include "item_func.h"
+
 enum Item_udftype {UDFTYPE_FUNCTION=1,UDFTYPE_AGGREGATE};
 
-typedef void (*Udf_func_clear)(UDF_INIT *, uchar *, uchar *);
-typedef void (*Udf_func_add)(UDF_INIT *, UDF_ARGS *, uchar *, uchar *);
-typedef void (*Udf_func_deinit)(UDF_INIT*);
-typedef bool (*Udf_func_init)(UDF_INIT *, UDF_ARGS *,  char *);
-typedef void (*Udf_func_any)();
-typedef double (*Udf_func_double)(UDF_INIT *, UDF_ARGS *, uchar *, uchar *);
-typedef int64_t (*Udf_func_int64_t)(UDF_INIT *, UDF_ARGS *, uchar *,
-                                      uchar *);
+typedef Item_func* (*create_func_item)(MEM_ROOT*);
 
-typedef struct st_udf_func
+struct udf_func
 {
   LEX_STRING name;
-  Item_result returns;
-  Item_udftype type;
-  Udf_func_any func;
-  Udf_func_init func_init;
-  Udf_func_deinit func_deinit;
-  Udf_func_clear func_clear;
-  Udf_func_add func_add;
-  void *data;
-} udf_func;
-
-class Item_result_field;
-
-class udf_handler :public Sql_alloc
-{
- protected:
-  udf_func *u_d;
-  String *buffers;
-  UDF_ARGS f_args;
-  UDF_INIT initid;
-  char *num_buffer;
-  uchar error, is_null;
-  bool initialized;
-  Item **args;
-
- public:
-  table_map used_tables_cache;
-  bool const_item_cache;
-  bool not_original;
-  udf_handler(udf_func *udf_arg) :u_d(udf_arg), buffers(0), error(0),
-    is_null(0), initialized(0), not_original(0)
-  {}
-  ~udf_handler();
-  const char *name() const { return u_d ? u_d->name.str : "?"; }
-  Item_result result_type () const
-  { return u_d	? u_d->returns : STRING_RESULT;}
-  bool get_arguments();
-  bool fix_fields(THD *thd, Item_result_field *item,
-		  uint arg_count, Item **args);
-  void cleanup();
-  double val(bool *null_value)
-  {
-    is_null= 0;
-    if (get_arguments())
-    {
-      *null_value=1;
-      return 0.0;
-    }
-    Udf_func_double func= (Udf_func_double) u_d->func;
-    double tmp=func(&initid, &f_args, &is_null, &error);
-    if (is_null || error)
-    {
-      *null_value=1;
-      return 0.0;
-    }
-    *null_value=0;
-    return tmp;
-  }
-  int64_t val_int(bool *null_value)
-  {
-    is_null= 0;
-    if (get_arguments())
-    {
-      *null_value=1;
-      return 0LL;
-    }
-    Udf_func_int64_t func= (Udf_func_int64_t) u_d->func;
-    int64_t tmp=func(&initid, &f_args, &is_null, &error);
-    if (is_null || error)
-    {
-      *null_value=1;
-      return 0LL;
-    }
-    *null_value=0;
-    return tmp;
-  }
-  my_decimal *val_decimal(bool *null_value, my_decimal *dec_buf);
-  void clear()
-  {
-    is_null= 0;
-    Udf_func_clear func= u_d->func_clear;
-    func(&initid, &is_null, &error);
-  }
-  void add(bool *null_value)
-  {
-    if (get_arguments())
-    {
-      *null_value=1;
-      return;
-    }
-    Udf_func_add func= u_d->func_add;
-    func(&initid, &f_args, &is_null, &error);
-    *null_value= (bool) (is_null || error);
-  }
-  String *val_str(String *str,String *save_str);
+  create_func_item create_func;
 };
 
-
 void udf_init(void),udf_free(void);
 udf_func *find_udf(const char *name, uint len=0);
 void free_udf(udf_func *udf);

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2008-09-21 14:47:59 +0000
+++ drizzled/sql_yacc.yy	2008-09-26 23:31:37 +0000
@@ -1553,11 +1553,6 @@
             Lex->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
             Lex->create_info.key_block_size= $3;
           }
-        | TRANSACTIONAL_SYM opt_equal choice
-          {
-	    Lex->create_info.used_fields|= HA_CREATE_USED_TRANSACTIONAL;
-            Lex->create_info.transactional= $3;
-          }
         ;
 
 default_collation:
@@ -3532,17 +3527,8 @@
           IDENT_sys '('
           {
             udf_func *udf= 0;
-            LEX *lex= Lex;
-            if (using_udf_functions &&
-                (udf= find_udf($1.str, $1.length)) &&
-                udf->type == UDFTYPE_AGGREGATE)
-            {
-              if (lex->current_select->inc_in_sum_expr())
-              {
-                my_parse_error(ER(ER_SYNTAX_ERROR));
-                DRIZZLE_YYABORT;
-              }
-            }
+	    udf= find_udf($1.str, $1.length);
+
             /* Temporary placing the result of find_udf in $3 */
             $<udf>$= udf;
           }
@@ -3572,11 +3558,6 @@
               udf_func *udf= $<udf>3;
               if (udf)
               {
-                if (udf->type == UDFTYPE_AGGREGATE)
-                {
-                  Select->in_sum_expr--;
-                }
-
                 item= Create_udf_func::s_singleton.create(thd, udf, $4);
 	      } else {
                 /* fix for bug 250065, from Andrew Garner <muzazzi@gmail.com> */

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2008-08-25 19:11:53 +0000
+++ drizzled/table.cc	2008-09-26 23:31:37 +0000
@@ -1970,8 +1970,7 @@
     int4store(fileinfo+34,create_info->avg_row_length);
     fileinfo[38]= (create_info->default_table_charset ?
 		   create_info->default_table_charset->number : 0);
-    fileinfo[39]= (uchar) ((uint) create_info->transactional |
-                           ((uint) create_info->page_checksum << 2));
+    fileinfo[39]= (uchar) create_info->page_checksum;
     fileinfo[40]= (uchar) create_info->row_type;
     /* Next few bytes where for RAID support */
     fileinfo[41]= 0;

=== added directory 'plugin/compress'
=== added file 'plugin/compress/Makefile.am'
--- plugin/compress/Makefile.am	1970-01-01 00:00:00 +0000
+++ plugin/compress/Makefile.am	2008-09-25 10:04:06 +0000
@@ -0,0 +1,32 @@
+# Copyright (C) 2006 MySQL AB
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+MYSQLDATAdir =          $(localstatedir)
+MYSQLSHAREdir =         $(pkgdatadir)
+MYSQLBASEdir=           $(prefix)
+MYSQLLIBdir=            $(pkglibdir)
+pkgplugindir =		$(pkglibdir)/plugin
+
+AM_CPPFLAGS = 		${GLOBAL_CPPFLAGS} -I${top_srcdir}/drizzled
+EXTRA_LTLIBRARIES =	libcompressudf.la
+pkgplugin_LTLIBRARIES =	@plugin_compress_shared_target@
+libcompressudf_la_LDFLAGS =	-module -rpath $(pkgplugindir) -lz
+libcompressudf_la_CXXFLAGS=	$(AM_CXXFLAGS) -DDRIZZLE_DYNAMIC_PLUGIN
+libcompressudf_la_SOURCES =	compressudf.cc
+
+
+EXTRA_LIBRARIES =	libcompressudf.a
+noinst_LIBRARIES =	@plugin_compress_static_target@
+libcompressudf_a_SOURCES=	$(libcompressudf_la_SOURCES)

=== added file 'plugin/compress/compressudf.cc'
--- plugin/compress/compressudf.cc	1970-01-01 00:00:00 +0000
+++ plugin/compress/compressudf.cc	2008-09-25 10:04:06 +0000
@@ -0,0 +1,136 @@
+/* Copyright (C) 2006 MySQL AB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
+
+#include <drizzled/common_includes.h>
+#include <drizzled/item_func.h>
+#include <drizzled/item_strfunc.h>
+#include <drizzled/drizzled_error_messages.h>
+#include <zlib.h>
+
+class Item_func_compress: public Item_str_func
+{
+  String buffer;
+public:
+  Item_func_compress():Item_str_func(){}
+  void fix_length_and_dec(){max_length= (args[0]->max_length*120)/100+12;}
+  const char *func_name() const{return "compress";}
+  String *val_str(String *) ;
+};
+
+String *Item_func_compress::val_str(String *str)
+{
+  int err= Z_OK, code;
+  ulong new_size;
+  String *res;
+  Byte *body;
+  char *tmp, *last_char;
+  assert(fixed == 1);
+
+  if (!(res= args[0]->val_str(str)))
+  {
+    null_value= 1;
+    return 0;
+  }
+  null_value= 0;
+  if (res->is_empty()) return res;
+
+  /*
+    Citation from zlib.h (comment for compress function):
+
+    Compresses the source buffer into the destination buffer.  sourceLen is
+    the byte length of the source buffer. Upon entry, destLen is the total
+    size of the destination buffer, which must be at least 0.1% larger than
+    sourceLen plus 12 bytes.
+    We assume here that the buffer can't grow more than .25 %.
+  */
+  new_size= res->length() + res->length() / 5 + 12;
+
+  // Check new_size overflow: new_size <= res->length()
+  if (((uint32_t) (new_size+5) <= res->length()) || 
+      buffer.realloc((uint32_t) new_size + 4 + 1))
+  {
+    null_value= 1;
+    return 0;
+  }
+
+  body= ((Byte*)buffer.ptr()) + 4;
+
+  // As far as we have checked res->is_empty() we can use ptr()
+  if ((err= compress(body, &new_size,
+		     (const Bytef*)res->ptr(), res->length())) != Z_OK)
+  {
+    code= err==Z_MEM_ERROR ? ER_ZLIB_Z_MEM_ERROR : ER_ZLIB_Z_BUF_ERROR;
+    push_warning(current_thd, DRIZZLE_ERROR::WARN_LEVEL_ERROR, code, ER(code));
+    null_value= 1;
+    return 0;
+  }
+
+  tmp= (char*)buffer.ptr(); // int4store is a macro; avoid side effects
+  int4store(tmp, res->length() & 0x3FFFFFFF);
+
+  /* This is to ensure that things works for CHAR fields, which trim ' ': */
+  last_char= ((char*)body)+new_size-1;
+  if (*last_char == ' ')
+  {
+    *++last_char= '.';
+    new_size++;
+  }
+
+  buffer.length((uint32_t)new_size + 4);
+  return &buffer;
+}
+
+
+Item_func* create_compressudf_item(MEM_ROOT* m)
+{
+  return  new (m) Item_func_compress();
+}
+
+static struct udf_func compressudf = {
+  { C_STRING_WITH_LEN("compress") },
+  create_compressudf_item
+};
+
+static int compressudf_plugin_init(void *p)
+{
+  udf_func **f = (udf_func**) p;
+
+  *f= &compressudf;
+
+  return 0;
+}
+
+static int compressudf_plugin_deinit(void *p)
+{
+  udf_func *udff = (udf_func *) p;
+  (void)udff;
+  return 0;
+}
+
+mysql_declare_plugin(compress)
+{
+  DRIZZLE_UDF_PLUGIN,
+  "compress",
+  "1.0",
+  "Stewart Smith",
+  "UDF for compress()",
+  PLUGIN_LICENSE_GPL,
+  compressudf_plugin_init, /* Plugin Init */
+  compressudf_plugin_deinit, /* Plugin Deinit */
+  NULL,   /* status variables */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+mysql_declare_plugin_end;

=== added file 'plugin/compress/plug.in'
--- plugin/compress/plug.in	1970-01-01 00:00:00 +0000
+++ plugin/compress/plug.in	2008-09-25 10:04:06 +0000
@@ -0,0 +1,5 @@
+DRIZZLE_PLUGIN(compress,[compress UDF],
+        [UDF Plugin for compress])
+DRIZZLE_PLUGIN_STATIC(compress,   [libcompressudf.a])
+DRIZZLE_PLUGIN_MANDATORY(compress)  dnl Default
+DRIZZLE_PLUGIN_DYNAMIC(compress,   [libcompressudf.la])

=== modified file 'plugin/crc32/crc32udf.cc'
--- plugin/crc32/crc32udf.cc	2008-08-12 21:13:01 +0000
+++ plugin/crc32/crc32udf.cc	2008-09-25 08:57:27 +0000
@@ -14,61 +14,47 @@
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
 
 #include <drizzled/common_includes.h>
+#include <drizzled/item_func.h>
 #include <zlib.h>
 
-bool udf_init_crc32udf(UDF_INIT *initid, UDF_ARGS *args, char *message)
-{
-  /* initid->ptr keeps state for between udf_init_foo and udf_deinit_foo */
-  initid->ptr= NULL;
-
-  if (args->arg_count != 1)
-   {
-      strcpy(message,"CRC32() requires one arguments");
-      return 1;
-   }
-
-   if (args->arg_type[0] != STRING_RESULT)
-   {
-      strcpy(message,"CRC32() requires a string");
-      return 1;
-   }
-
-  return 0;
-}
-
-long long udf_doit_crc32(UDF_INIT *initid, UDF_ARGS *args, char *result,
-                         unsigned long *length, char *is_null, char *error)
-{
-  (void)initid;
-  (void)result;
-  (void)length;
-  (void)is_null;
-  (void)error;
-  return (long long) crc32(0L, (uchar*)args->args[0], args->lengths[0]);
-}
-
-void udf_deinit_crc32udf(UDF_INIT *initid)
-{
-  (void)initid;
-  /* if we allocated initid->ptr, free it here */
-  return;
-}
-
+class Item_func_crc32 :public Item_int_func
+{
+  String value;
+public:
+  Item_func_crc32() :Item_int_func() { unsigned_flag= 1; }
+  const char *func_name() const { return "crc32"; }
+  void fix_length_and_dec() { max_length=10; }
+  int64_t val_int();
+};
+
+int64_t Item_func_crc32::val_int()
+{
+  assert(fixed == 1);
+  String *res=args[0]->val_str(&value);
+  if (!res)
+  {
+    null_value=1;
+    return 0; /* purecov: inspected */
+  }
+  null_value=0;
+  return (int64_t) crc32(0L, (uchar*)res->ptr(), res->length());
+}
+
+Item_func* create_crc32udf_item(MEM_ROOT* m)
+{
+  return  new (m) Item_func_crc32();
+}
+
+static struct udf_func crc32udf = {
+  { C_STRING_WITH_LEN("crc32") },
+  create_crc32udf_item
+};
 
 static int crc32udf_plugin_init(void *p)
 {
-  udf_func *udff= (udf_func *) p;
-  static char crc32str[6];
-
-  strcpy(crc32str,"crc32");
-
-  udff->name.str= crc32str;
-  udff->name.length= strlen("crc32");
-  udff->type= UDFTYPE_FUNCTION;
-  udff->returns= INT_RESULT;
-  udff->func_init= udf_init_crc32udf;
-  udff->func_deinit= udf_deinit_crc32udf;
-  udff->func= (Udf_func_any) udf_doit_crc32;
+  udf_func **f = (udf_func**) p;
+
+  *f= &crc32udf;
 
   return 0;
 }

=== modified file 'plugin/crc32/plug.in'
--- plugin/crc32/plug.in	2008-08-12 21:13:01 +0000
+++ plugin/crc32/plug.in	2008-09-25 08:57:27 +0000
@@ -1,3 +1,5 @@
 DRIZZLE_PLUGIN(crc32,[crc32 UDF],
         [UDF Plugin for crc32])
+DRIZZLE_PLUGIN_STATIC(crc32,   [libcrc32udf.a])
+DRIZZLE_PLUGIN_MANDATORY(crc32)  dnl Default
 DRIZZLE_PLUGIN_DYNAMIC(crc32,   [libcrc32udf.la])

=== modified file 'plugin/hello_world/hello_world.cc'
--- plugin/hello_world/hello_world.cc	2008-08-12 21:13:01 +0000
+++ plugin/hello_world/hello_world.cc	2008-09-25 08:57:27 +0000
@@ -14,83 +14,49 @@
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
 
 #include <drizzled/common_includes.h>
+#include <drizzled/item_func.h>
+#include <drizzled/item_strfunc.h>
 
-bool udf_init_hello_world(UDF_INIT *initid, UDF_ARGS *args, char *message)
+class Item_func_hello_world : public Item_str_func
 {
-  /* this is how to fail */
-  if (args->arg_count != 0)  {
-    strncpy(message, "Too many arguments", DRIZZLE_ERRMSG_SIZE);
-    return 1;
+public:
+  const char *func_name() const { return "hello_world"; }
+  String *val_str(String* s) {
+    s->set(STRING_WITH_LEN("Hello World!"),system_charset_info);
+    return s;
+  };
+  void fix_length_and_dec() {
+    max_length=strlen("Hello World!");
   }
-
-  /* initid->ptr keeps state for between udf_init_foo and udf_deinit_foo */
-  initid->ptr= NULL;
-
-  return 0;
-}
-
-char *udf_doit_hello_world(UDF_INIT *initid, UDF_ARGS *args, char *result,
-			   unsigned long *length, char *is_null, char *error)
-{
-  /* We don't use these, so void them out */
-  (void)initid;
-  (void)args;
-
-  /* "result" is preallocated 255 bytes for me, if i want to use it */
-  strncpy(result, "Hello, world!", 255);
-
-  /* if set to 255 or less, MySQL treats the result as a varchar
-     if set to greater than 255, MySQL treats the result as a blob */
-  *length= strlen("Hello, world!");
-
-  /* is_null is already zero, this is a demonstration */
-  *is_null= 0;
-
-  /* error is already zero, this is a demonstration */
-  *error= 0;
-
-  return result;
-}
-
-void udf_deinit_hello_world(UDF_INIT *initid)
-{
-  /* We don't use this, so void it out */
-  (void)initid;
-
-  /* if we allocated initid->ptr, free it here */
-  return;
-}
-
+};
+
+Item_func* create_hello_world_udf_item(MEM_ROOT* m)
+{
+  return  new (m) Item_func_hello_world();
+}
+
+static struct udf_func hello_world_udf = {
+  { C_STRING_WITH_LEN("hello_world") },
+  create_hello_world_udf_item
+};
 
 static int hello_world_plugin_init(void *p)
 {
-  udf_func *udff= (udf_func *) p;
+  udf_func **f = (udf_func**) p;
 
-  udff->name.str= (char *)"hello_world";
-  udff->name.length= strlen("hello_world");
-  udff->type= UDFTYPE_FUNCTION;
-  udff->returns= STRING_RESULT;
-  udff->func_init= udf_init_hello_world;
-  udff->func_deinit= udf_deinit_hello_world;
-  udff->func= (Udf_func_any) udf_doit_hello_world;
+  *f= &hello_world_udf;
 
   return 0;
 }
 
 static int hello_world_plugin_deinit(void *p)
 {
-  /* We don't use this, so void it out */
-  (void)p;
-
-  /* There is nothing to de-init here, but if 
-   * something is needed from the udf_func, it 
-   * can be had from p with:
-   *   udf_func *udff = (udf_func *) p;
-   */
-
+  udf_func *udff = (udf_func *) p;
+  (void)udff;
   return 0;
 }
 
+
 mysql_declare_plugin(hello_world)
 {
   DRIZZLE_UDF_PLUGIN,

=== modified file 'plugin/md5/Makefile.am'
--- plugin/md5/Makefile.am	2008-08-12 21:13:01 +0000
+++ plugin/md5/Makefile.am	2008-09-25 08:57:27 +0000
@@ -28,7 +28,6 @@
 libmd5udf_la_CXXFLAGS=	-DDRIZZLE_DYNAMIC_PLUGIN
 libmd5udf_la_SOURCES =	md5udf.cc
 
-
 EXTRA_LIBRARIES =	libmd5udf.a
 noinst_LIBRARIES =	@plugin_md5_static_target@
 libmd5udf_a_SOURCES=	$(libmd5udf_la_SOURCES)

=== modified file 'plugin/md5/md5udf.cc'
--- plugin/md5/md5udf.cc	2008-08-12 21:13:01 +0000
+++ plugin/md5/md5udf.cc	2008-09-25 08:57:27 +0000
@@ -14,82 +14,74 @@
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
 
 #include <drizzled/common_includes.h>
+#include <drizzled/item_func.h>
+#include <drizzled/item_strfunc.h>
+
 #include <openssl/md5.h>
 
-bool udf_init_md5udf(UDF_INIT *initid, UDF_ARGS *args, char *message)
-{
-  /* initid->ptr keeps state for between udf_init_foo and udf_deinit_foo */
-  initid->ptr= NULL;
-
-  if (args->arg_count != 1)
-   {
-      strcpy(message,"MD5() requires one arguments");
-      return 1;
-   }
-
-   if (args->arg_type[0] != STRING_RESULT)
-   {
-      strcpy(message,"MD5() requires a string");
-      return 1;
-   }
-
+class Item_func_md5 : public Item_str_func
+{
+public:
+  const char *func_name() const { return "md5"; }
+  String *val_str(String*);
+  void fix_length_and_dec() {
+    max_length=32;
+    args[0]->collation.set(
+      get_charset_by_csname(args[0]->collation.collation->csname,
+                            MY_CS_BINSORT,MYF(0)), DERIVATION_COERCIBLE);
+  }
+
+};
+
+
+String *Item_func_md5::val_str(String *str)
+{
+  assert(fixed == 1);
+  String * sptr= args[0]->val_str(str);
+  str->set_charset(&my_charset_bin);
+  if (sptr)
+  {
+    MD5_CTX context;
+    uchar digest[16];
+
+    null_value=0;
+    MD5_Init (&context);
+    MD5_Update (&context,(uchar *) sptr->ptr(), sptr->length());
+    MD5_Final (digest, &context);
+    if (str->alloc(32))				// Ensure that memory is free
+    {
+      null_value=1;
+      return 0;
+    }
+    snprintf((char *) str->ptr(), 33,
+	    "%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
+	    digest[0], digest[1], digest[2], digest[3],
+	    digest[4], digest[5], digest[6], digest[7],
+	    digest[8], digest[9], digest[10], digest[11],
+	    digest[12], digest[13], digest[14], digest[15]);
+    str->length((uint) 32);
+    return str;
+  }
+  null_value=1;
   return 0;
 }
 
-char *udf_doit_md5(UDF_INIT *initid, UDF_ARGS *args, char *result,
-			   unsigned long *length, char *is_null, char *error)
-{
-  MD5_CTX context;
-  uchar digest[16];
-
-  (void)initid;
-
-  MD5_Init(&context);
-
-  MD5_Update(&context, args->args[0], args->lengths[0]);
-
-  MD5_Final(digest, &context);
-
-  sprintf(result,
-          "%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
-          digest[0], digest[1], digest[2], digest[3],
-          digest[4], digest[5], digest[6], digest[7],
-          digest[8], digest[9], digest[10], digest[11],
-          digest[12], digest[13], digest[14], digest[15]);
-
-  *length= 32;
-
-  /* is_null is already zero, this is a demonstration */
-  *is_null= 0;
-
-  /* error is already zero, this is a demonstration */
-  *error= 0;
-
-  return result;
-}
-
-void udf_deinit_md5udf(UDF_INIT *initid)
-{
-  (void)initid;
-  /* if we allocated initid->ptr, free it here */
-  return;
-}
-
+
+Item_func* create_md5udf_item(MEM_ROOT* m)
+{
+  return  new (m) Item_func_md5();
+}
+
+struct udf_func md5udf = {
+  { C_STRING_WITH_LEN("md5") },
+  create_md5udf_item
+};
 
 static int md5udf_plugin_init(void *p)
 {
-  udf_func *udff= (udf_func *) p;
-  static char md5str[4];
-
-  strcpy(md5str, "md5");
-
-  udff->name.str= md5str;
-  udff->name.length= strlen("md5");
-  udff->type= UDFTYPE_FUNCTION;
-  udff->returns= STRING_RESULT;
-  udff->func_init= udf_init_md5udf;
-  udff->func_deinit= udf_deinit_md5udf;
-  udff->func= (Udf_func_any) udf_doit_md5;
+  udf_func **f = (udf_func**) p;
+
+  *f= &md5udf;
 
   return 0;
 }

=== modified file 'plugin/md5/plug.in'
--- plugin/md5/plug.in	2008-08-12 21:13:01 +0000
+++ plugin/md5/plug.in	2008-09-25 08:57:27 +0000
@@ -1,5 +1,6 @@
 DRIZZLE_PLUGIN(md5,[MD5 UDF],
         [UDF Plugin for MD5])
+DRIZZLE_PLUGIN_STATIC(md5,   [libmd5udf.a])
 DRIZZLE_PLUGIN_DYNAMIC(md5,   [libmd5udf.la])
 DRIZZLE_PLUGIN_ACTIONS(md5,  [
   AC_CHECK_HEADERS(openssl/md5.h)

=== added directory 'plugin/uncompress'
=== added file 'plugin/uncompress/Makefile.am'
--- plugin/uncompress/Makefile.am	1970-01-01 00:00:00 +0000
+++ plugin/uncompress/Makefile.am	2008-09-25 10:04:06 +0000
@@ -0,0 +1,32 @@
+# Copyright (C) 2006 MySQL AB
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+MYSQLDATAdir =          $(localstatedir)
+MYSQLSHAREdir =         $(pkgdatadir)
+MYSQLBASEdir=           $(prefix)
+MYSQLLIBdir=            $(pkglibdir)
+pkgplugindir =		$(pkglibdir)/plugin
+
+AM_CPPFLAGS = 		${GLOBAL_CPPFLAGS} -I${top_srcdir}/drizzled
+EXTRA_LTLIBRARIES =	libuncompressudf.la
+pkgplugin_LTLIBRARIES =	@plugin_uncompress_shared_target@
+libuncompressudf_la_LDFLAGS =	-module -rpath $(pkgplugindir) -lz
+libuncompressudf_la_CXXFLAGS=	$(AM_CXXFLAGS) -DDRIZZLE_DYNAMIC_PLUGIN
+libuncompressudf_la_SOURCES =	uncompressudf.cc
+
+
+EXTRA_LIBRARIES =	libuncompressudf.a
+noinst_LIBRARIES =	@plugin_uncompress_static_target@
+libuncompressudf_a_SOURCES=	$(libuncompressudf_la_SOURCES)

=== added file 'plugin/uncompress/plug.in'
--- plugin/uncompress/plug.in	1970-01-01 00:00:00 +0000
+++ plugin/uncompress/plug.in	2008-09-25 10:04:06 +0000
@@ -0,0 +1,5 @@
+DRIZZLE_PLUGIN(uncompress,[uncompress UDF],
+        [UDF Plugin for uncompress])
+DRIZZLE_PLUGIN_STATIC(uncompress,   [libuncompressudf.a])
+DRIZZLE_PLUGIN_MANDATORY(uncompress)  dnl Default
+DRIZZLE_PLUGIN_DYNAMIC(uncompress,   [libuncompressudf.la])

=== added file 'plugin/uncompress/uncompressudf.cc'
--- plugin/uncompress/uncompressudf.cc	1970-01-01 00:00:00 +0000
+++ plugin/uncompress/uncompressudf.cc	2008-09-25 10:04:06 +0000
@@ -0,0 +1,125 @@
+/* Copyright (C) 2006 MySQL AB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
+
+#define DRIZZLE_SERVER 1 /* for thd variable max_allowed_packet */
+#include <drizzled/server_includes.h>
+#include <drizzled/drizzled_error_messages.h>
+
+#include <zlib.h>
+
+class Item_func_uncompress: public Item_str_func
+{
+  String buffer;
+public:
+  Item_func_uncompress(): Item_str_func(){}
+  void fix_length_and_dec(){ maybe_null= 1; max_length= MAX_BLOB_WIDTH; }
+  const char *func_name() const{return "uncompress";}
+  String *val_str(String *) ;
+};
+
+String *Item_func_uncompress::val_str(String *str)
+{
+  assert(fixed == 1);
+  String *res= args[0]->val_str(str);
+  ulong new_size;
+  int err;
+  uint code;
+
+  if (!res)
+    goto err;
+  null_value= 0;
+  if (res->is_empty())
+    return res;
+
+  /* If length is less than 4 bytes, data is corrupt */
+  if (res->length() <= 4)
+  {
+    push_warning_printf(current_thd, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
+			ER_ZLIB_Z_DATA_ERROR,
+			ER(ER_ZLIB_Z_DATA_ERROR));
+    goto err;
+  }
+
+  /* Size of uncompressed data is stored as first 4 bytes of field */
+  new_size= uint4korr(res->ptr()) & 0x3FFFFFFF;
+  if (new_size > current_thd->variables.max_allowed_packet)
+  {
+    push_warning_printf(current_thd, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
+			ER_TOO_BIG_FOR_UNCOMPRESS,
+			ER(ER_TOO_BIG_FOR_UNCOMPRESS),
+                        current_thd->variables.max_allowed_packet);
+    goto err;
+  }
+  if (buffer.realloc((uint32_t)new_size))
+    goto err;
+
+  if ((err= uncompress((Byte*)buffer.ptr(), &new_size,
+		       ((const Bytef*)res->ptr())+4,res->length())) == Z_OK)
+  {
+    buffer.length((uint32_t) new_size);
+    return &buffer;
+  }
+
+  code= ((err == Z_BUF_ERROR) ? ER_ZLIB_Z_BUF_ERROR :
+	 ((err == Z_MEM_ERROR) ? ER_ZLIB_Z_MEM_ERROR : ER_ZLIB_Z_DATA_ERROR));
+  push_warning(current_thd, DRIZZLE_ERROR::WARN_LEVEL_ERROR, code, ER(code));
+
+err:
+  null_value= 1;
+  return 0;
+}
+
+
+Item_func* create_uncompressudf_item(MEM_ROOT* m)
+{
+  return  new (m) Item_func_uncompress();
+}
+
+static struct udf_func uncompressudf = {
+  { C_STRING_WITH_LEN("uncompress") },
+  create_uncompressudf_item
+};
+
+static int uncompressudf_plugin_init(void *p)
+{
+  udf_func **f = (udf_func**) p;
+
+  *f= &uncompressudf;
+
+  return 0;
+}
+
+static int uncompressudf_plugin_deinit(void *p)
+{
+  udf_func *udff = (udf_func *) p;
+  (void)udff;
+  return 0;
+}
+
+mysql_declare_plugin(uncompress)
+{
+  DRIZZLE_UDF_PLUGIN,
+  "uncompress",
+  "1.0",
+  "Stewart Smith",
+  "UDF for compress()",
+  PLUGIN_LICENSE_GPL,
+  uncompressudf_plugin_init, /* Plugin Init */
+  uncompressudf_plugin_deinit, /* Plugin Deinit */
+  NULL,   /* status variables */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+mysql_declare_plugin_end;

=== added directory 'plugin/uncompressed_length'
=== added file 'plugin/uncompressed_length/Makefile.am'
--- plugin/uncompressed_length/Makefile.am	1970-01-01 00:00:00 +0000
+++ plugin/uncompressed_length/Makefile.am	2008-09-25 10:04:06 +0000
@@ -0,0 +1,32 @@
+# Copyright (C) 2006 MySQL AB
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+MYSQLDATAdir =          $(localstatedir)
+MYSQLSHAREdir =         $(pkgdatadir)
+MYSQLBASEdir=           $(prefix)
+MYSQLLIBdir=            $(pkglibdir)
+pkgplugindir =		$(pkglibdir)/plugin
+
+AM_CPPFLAGS = 		${GLOBAL_CPPFLAGS} -I${top_srcdir}/drizzled
+EXTRA_LTLIBRARIES =	libuncompressed_lengthudf.la
+pkgplugin_LTLIBRARIES =	@plugin_uncompressed_length_shared_target@
+libuncompressed_lengthudf_la_LDFLAGS =	-module -rpath $(pkgplugindir)
+libuncompressed_lengthudf_la_CXXFLAGS=	$(AM_CXXFLAGS) -DDRIZZLE_DYNAMIC_PLUGIN
+libuncompressed_lengthudf_la_SOURCES =	uncompressed_length.cc
+
+
+EXTRA_LIBRARIES =	libuncompressed_lengthudf.a
+noinst_LIBRARIES =	@plugin_uncompressed_length_static_target@
+libuncompressed_lengthudf_a_SOURCES=	$(libuncompressed_lengthudf_la_SOURCES)

=== added file 'plugin/uncompressed_length/plug.in'
--- plugin/uncompressed_length/plug.in	1970-01-01 00:00:00 +0000
+++ plugin/uncompressed_length/plug.in	2008-09-25 10:04:06 +0000
@@ -0,0 +1,5 @@
+DRIZZLE_PLUGIN(uncompressed_length,[uncompressed_length UDF],
+        [UDF Plugin for uncompressed_length])
+DRIZZLE_PLUGIN_STATIC(uncompressed_length,   [libuncompressed_lengthudf.a])
+DRIZZLE_PLUGIN_MANDATORY(uncompressed_length)  dnl Default
+DRIZZLE_PLUGIN_DYNAMIC(uncompressed_length,   [libuncompressed_lengthudf.la])

=== added file 'plugin/uncompressed_length/uncompressed_length.cc'
--- plugin/uncompressed_length/uncompressed_length.cc	1970-01-01 00:00:00 +0000
+++ plugin/uncompressed_length/uncompressed_length.cc	2008-09-25 10:04:06 +0000
@@ -0,0 +1,91 @@
+/* Copyright (C) 2006 MySQL AB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
+
+#include <drizzled/common_includes.h>
+#include <drizzled/item_func.h>
+
+class Item_func_uncompressed_length : public Item_int_func
+{
+  String value;
+public:
+  Item_func_uncompressed_length():Item_int_func(){}
+  const char *func_name() const{return "uncompressed_length";}
+  void fix_length_and_dec() { max_length=10; }
+  int64_t val_int();
+};
+
+int64_t Item_func_uncompressed_length::val_int()
+{
+  assert(fixed == 1);
+  String *res= args[0]->val_str(&value);
+  if (!res)
+  {
+    null_value=1;
+    return 0; /* purecov: inspected */
+  }
+  null_value=0;
+  if (res->is_empty()) return 0;
+
+  /*
+    res->ptr() using is safe because we have tested that string is not empty,
+    res->c_ptr() is not used because:
+      - we do not need \0 terminated string to get first 4 bytes
+      - c_ptr() tests simbol after string end (uninitialiozed memory) which
+        confuse valgrind
+  */
+  return uint4korr(res->ptr()) & 0x3FFFFFFF;
+}
+
+Item_func* create_uncompressed_lengthudf_item(MEM_ROOT* m)
+{
+  return  new (m) Item_func_uncompressed_length();
+}
+
+static struct udf_func uncompressed_lengthudf = {
+  { C_STRING_WITH_LEN("uncompressed_length") },
+  create_uncompressed_lengthudf_item
+};
+
+static int uncompressed_lengthudf_plugin_init(void *p)
+{
+  udf_func **f = (udf_func**) p;
+
+  *f= &uncompressed_lengthudf;
+
+  return 0;
+}
+
+static int uncompressed_lengthudf_plugin_deinit(void *p)
+{
+  udf_func *udff = (udf_func *) p;
+  (void)udff;
+  return 0;
+}
+
+mysql_declare_plugin(uncompressed_length)
+{
+  DRIZZLE_UDF_PLUGIN,
+  "uncompressed_length",
+  "1.0",
+  "Stewart Smith",
+  "UDF for compress()",
+  PLUGIN_LICENSE_GPL,
+  uncompressed_lengthudf_plugin_init, /* Plugin Init */
+  uncompressed_lengthudf_plugin_deinit, /* Plugin Deinit */
+  NULL,   /* status variables */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+mysql_declare_plugin_end;

=== modified file 'tests/Makefile.am'
--- tests/Makefile.am	2008-09-11 16:03:22 +0000
+++ tests/Makefile.am	2008-09-25 10:04:06 +0000
@@ -160,6 +160,7 @@
         func_isnull \
         func_like \
 				func_math \
+	func_compress \
         greedy_optimizer \
         group_min_max_innodb \
         heap_auto_increment \

=== modified file 'tests/r/func_compress.result'
--- tests/r/func_compress.result	2008-06-25 05:29:13 +0000
+++ tests/r/func_compress.result	2008-09-25 10:04:06 +0000
@@ -26,7 +26,7 @@
 select length(compress(@test_compress_string))<length(@test_compress_string);
 length(compress(@test_compress_string))<length(@test_compress_string)
 1
-create table t1 (a text, b char(255), c char(4)) engine=myisam;
+create table t1 (a blob, b blob, c varchar(4));
 insert into t1 (a,b,c) values (compress(@test_compress_string),compress(@test_compress_string),'d ');
 select uncompress(a) from t1;
 uncompress(a)
@@ -36,7 +36,7 @@
 string for test compress function aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa 
 select concat('|',c,'|') from t1;
 concat('|',c,'|')
-|d|
+|d |
 drop table t1;
 select compress("");
 compress("")
@@ -50,7 +50,7 @@
 select uncompressed_length("");
 uncompressed_length("")
 0
-create table t1 (a text);
+create table t1 (a blob);
 insert t1 values (compress(null)), ('A\0\0\0BBBBBBBB'), (compress(space(50000))), (space(50000));
 select length(a) from t1;
 length(a)
@@ -83,7 +83,7 @@
 insert into t1 values ('0'), (NULL), ('0');
 select compress(a), compress(a) from t1;
 select compress(a) is null from t1;
-compress(a) is null
+compress(a) is null 
 0
 1
 0
@@ -93,9 +93,7 @@
 insert into t1 values ('foo');
 explain select * from t1 where uncompress(a) is null;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	system	NULL	NULL	NULL	NULL	1	
-Warnings:
-Error	1259	ZLIB: Input data corrupted
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	1	Using where
 select * from t1 where uncompress(a) is null;
 a
 foo
@@ -103,14 +101,14 @@
 Error	1259	ZLIB: Input data corrupted
 explain select *, uncompress(a) from t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	system	NULL	NULL	NULL	NULL	1	
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	1	
 select *, uncompress(a) from t1;
 a	uncompress(a)
 foo	NULL
 Warnings:
 Error	1259	ZLIB: Input data corrupted
 select *, uncompress(a), uncompress(a) is null from t1;
-a	uncompress(a)	uncompress(a) is null
+a	uncompress(a)	uncompress(a) is null 
 foo	NULL	1
 Warnings:
 Error	1259	ZLIB: Input data corrupted

=== added file 'tests/r/func_crc32.result'
--- tests/r/func_crc32.result	1970-01-01 00:00:00 +0000
+++ tests/r/func_crc32.result	2008-09-25 08:57:27 +0000
@@ -0,0 +1,9 @@
+select crc32('12341234');
+crc32('12341234')
+2136042507
+select crc32('a');
+crc32('a')
+3904355907
+select crc32('taohuoahusoahusoa haneo uhnteoahu ntoahu saonhu aoeuoa hun');
+crc32('taohuoahusoahusoa haneo uhnteoahu ntoahu saonhu aoeuoa hun')
+734998015

=== modified file 'tests/t/func_compress.test'
--- tests/t/func_compress.test	2008-06-25 05:29:13 +0000
+++ tests/t/func_compress.test	2008-09-25 10:04:06 +0000
@@ -1,4 +1,4 @@
--- source include/have_compress.inc
+#-- source include/have_compress.inc
 #
 # Test for compress and uncompress functions:
 #
@@ -15,7 +15,7 @@
 select uncompressed_length(compress(@test_compress_string));
 select length(compress(@test_compress_string))<length(@test_compress_string);
 
-create table t1 (a text, b char(255), c char(4)) engine=myisam;
+create table t1 (a blob, b blob, c varchar(4));
 insert into t1 (a,b,c) values (compress(@test_compress_string),compress(@test_compress_string),'d ');
 select uncompress(a) from t1;
 select uncompress(b) from t1;
@@ -31,7 +31,7 @@
 # errors
 #
 
-create table t1 (a text);
+create table t1 (a blob);
 insert t1 values (compress(null)), ('A\0\0\0BBBBBBBB'), (compress(space(50000))), (space(50000));
 select length(a) from t1;
 select length(uncompress(a)) from t1;

=== added file 'tests/t/func_crc32.test'
--- tests/t/func_crc32.test	1970-01-01 00:00:00 +0000
+++ tests/t/func_crc32.test	2008-09-25 08:57:27 +0000
@@ -0,0 +1,3 @@
+select crc32('12341234');
+select crc32('a');
+select crc32('taohuoahusoahusoa haneo uhnteoahu ntoahu saonhu aoeuoa hun');

